DROP TABLE IF EXISTS Mark;
DROP TABLE IF EXISTS Lecture;
DROP TABLE IF EXISTS Student;

CREATE TABLE Student (
  matriculation INT PRIMARY KEY,
  name VARCHAR(100) NOT NULL
);

CREATE TABLE Lecture (
  id INT PRIMARY KEY,
  title VARCHAR(255) NOT NULL
);

CREATE TABLE Mark (
   student INT NOT NULL REFERENCES Student,
   lecture INT NOT NULL REFERENCES Lecture,
   mark CHAR(3) NOT NULL,
   status CHAR(12) NULL,
   CHECK (status IN ('final', 'preliminary')),
   PRIMARY KEY(student, lecture)
);

/* Inserting students */
INSERT INTO Student VALUES(12345, 'Jim Knopf');
INSERT INTO Student VALUES(55621, 'Eva Morales');
INSERT INTO Student VALUES(54321, 'Kim Wilde');

/* Inserting lectures */
INSERT INTO Lecture VALUES(113105, 'Software Development 1');
INSERT INTO Lecture VALUES(113771, 'Database systems');
INSERT INTO Lecture VALUES(113305, 'Structured Data and applications 1');

/* Inserting marks */
INSERT INTO Mark VALUES(12345, 113105, '1,7', 'final');
INSERT INTO Mark VALUES(12345, 113771, '2,3');
INSERT INTO Mark VALUES(55621, 113771, '1,0');
INSERT INTO Mark VALUES(54321, 113771, '3,0', 'preliminary');
INSERT INTO Mark VALUES(12345, 113305, '2,0');

SELECT * FROM Mark;
